import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
public class canvas extends Canvas
{
    midlet ml;
    long bf, bf2;
    int w, h, index = 0, x = 20, n = 0, l = 0, k, speed = 0;
    Image l1, l2;
    TiledLayer tl, ta;
    int[] map1 = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
    int[][] map2 = {{1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2}, {2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1}};
    Image[] t = new Image[6];
    Image[] c = new Image[6];
    Image[] d = new Image[2];
    boolean phim = false, look = true;
    Sprite[] st = new Sprite[6];
    Sprite[] sc = new Sprite[6];
    Sprite[] sd = new Sprite[2];
    public canvas(midlet ml)
    {
        this.ml = ml;
        setFullScreenMode(true);
        w = getWidth();
        h = getHeight();
        bf = now();
        bf2 = now();
        try
        {
            l1 = Image.createImage("/l1.png");
            l2 = Image.createImage("/l2.png");
            for (int i = 0; i < 6; i++)
            {
                t[i] = Image.createImage("/in/t" + String.valueOf(i) + ".png");
                c[i] = Image.createImage("/in/c" + String.valueOf(i) + ".png");
            }
            d[0] = Image.createImage("/in/d0.png");
            d[1] = Image.createImage("/in/d1.png");
        } catch(Exception e)
        {
        }
        for (int i = 0; i < 6; i++)
        {
            st[i] = new Sprite(t[i], t[i] . getWidth(), t[i] . getHeight());
            sc[i] = new Sprite(c[i], c[i] . getWidth(), c[i] . getHeight());
        }
        for (int i = 0; i < 2; i++)
        {
            sd[i] = new Sprite(d[i], d[i] . getWidth(), d[i] . getHeight());
        }
    }
    public void add()
    {
        tl = new TiledLayer(14, 1, l2, 24, 48);
        for (int i = 0; i < map1.length; i++)
        {
            int col = i % 14;
            int row = (i - col) / 1;
            tl.setCell(col, row, map1[i]);
        }
    }
    public void use(int[] a)
    {
        ta = new TiledLayer(14, 1, l1, 24, 24);
        for (int i = 0; i < a.length; i++)
        {
            int col = i % 14;
            int row = (i - col) / 1;
            ta.setCell(col, row, a[i]);
        }
    }
    public void paint(Graphics g)
    {
        g.setColor(0xffffff);
        g.fillRect(0, 0, w, h);
        add();
        tl.setPosition(0, h - 48);
        tl.paint(g);
        if (now() - bf >= 1000)
        {
            index++;
            bf = now();
        }
        index %= 2;
        use(map2[index]);
        ta.setPosition(0, h - 72);
        ta.paint(g);
        if (look)
        {
            for (int i = 0; i < 6; i++)
            {
                sc[i] . setTransform(0);
                st[i] . setTransform(0);
            }
            sd[0] . setTransform(0);
            sd[1] . setTransform(0);
        }
        else
        {
            for (int i = 0; i < 6; i++)
            {
                sc[i] . setTransform(2);
                st[i] . setTransform(2);
            }
            sd[0] . setTransform(2);
            sd[1] . setTransform(2);
        }
        if (phim)
        {
            move();
            n = 1;
            l = 1;
            if (now() - bf2 >= 500)
            {
                n++;
                x += speed;
                if (n > 5) n = 1;
                if (look && x > w - 10) x = w - 10;
                if (!look && x < 0) x = 0;
                sc[n] . setPosition(x, h - 72 - c[n] . getHeight());
                sc[n] . setFrame(0);
                st[n] . setPosition(x - 3, h - 70 - 2 * c[n] . getHeight());
                st[n] . setFrame(0);
                sd[l] . setPosition(x - 3, h - 70 - 3 * c[n] . getHeight() - t[n] . getHeight());
                sd[l] . setFrame(0);
                bf2 = now();
                sc[n] . paint(g);
                st[n] . paint(g);
                sd[l] . paint(g);
            }
        }
        else
        {
            n = 0;
            l = 0;
            speed = 0;
            sc[n] . setPosition(x, h - 72 - c[n] . getHeight());
            sc[n] . setFrame(0);
            st[n] . setPosition(x - 3, h - 72 - 2 * c[n] . getHeight());
            st[n] . setFrame(0);
            sd[l] . setPosition(x - 3, h - 70 - 3 * c[n] . getHeight() - t[n] . getHeight());
            sd[l] . setFrame(0);
            st[l] . paint(g);
            sc[l] . paint(g);
            sd[l] . paint(g);
        }
        repaint();
        try
        {
            Thread.sleep(50);
        } catch(Exception e)
        {
        }
    }
    public void move()
    {
        if (k == -4)
        {
            look = true;
            speed = 2;
        }
        if (k == -3)
        {
            look = false;
            speed = -2;
        }
    }
    public void keyPressed(int k)
    {
        this.k = k;
        phim = true;
    }
    public void keyReleased(int k)
    {
        phim = false;
    }
    long now()
    {
        return System.currentTimeMillis();
    }
}